AWSTemplateFormatVersion: '2010-09-09'
Transform: 'AWS::Serverless-2016-10-31'

Resources:

  # Lambda Functions Informe Persona
  InformePersonaFunction:
    Type: AWS::Serverless::Function
    Properties:
      Handler: handler.informePersona
      CodeUri: ./informePersona
      Runtime: nodejs16.x
      Events:
        MyAPI:
          Type: Api
          Properties:
            Path: /informePersona
            Method: POST
            RestApiId:
              Ref: UnifiedApi                 

  # Lambda Functions Transaction
  TransactionsFunction:
    Type: AWS::Serverless::Function
    Properties:
      Handler: handler.transactions
      CodeUri: ./transactions
      Runtime: nodejs16.x
      Policies:
        - DynamoDBCrudPolicy:
            TableName: !Ref TrxMovimientosTable      
      Events:
        MyAPI:
          Type: Api
          Properties:
            Path: /transaction
            Method: POST
            RestApiId:
              Ref: TransactionApi                 
      Environment:
        Variables:
          TABLE_NAME: !Ref TrxMovimientosTable

  GenerateJWTFunction:
    Type: AWS::Serverless::Function
    Properties:
      Handler: handler.generateJWT
      CodeUri: ./generateJWT
      Runtime: nodejs16.x
      Policies:
        - DynamoDBCrudPolicy:
            TableName: !Ref TrxMovimientosTable
        - DynamoDBCrudPolicy:
            TableName: !Ref TenantTable            
      Events:
        MyAPI:
          Type: Api
          Properties:
            Path: /generateJWT
            Method: POST
            RestApiId:
              Ref: UnifiedApi            
      Environment:
        Variables:
          TABLE_NAME: !Ref TrxMovimientosTable

  TrxMovimientosTable:
    Type: AWS::DynamoDB::Table
    Properties:
      TableName: TrxMovimientos
      AttributeDefinitions:
        - AttributeName: id
          AttributeType: S
      KeySchema:
        - AttributeName: id
          KeyType: HASH
      ProvisionedThroughput:
        ReadCapacityUnits: 1
        WriteCapacityUnits: 1

  TenantTable:
    Type: AWS::DynamoDB::Table
    Properties:
      TableName: Tenant
      AttributeDefinitions:
        - AttributeName: id
          AttributeType: S
      KeySchema:
        - AttributeName: id
          KeyType: HASH
      ProvisionedThroughput:
        ReadCapacityUnits: 1
        WriteCapacityUnits: 1    

  Oauth2TokenFunction:
    Type: AWS::Serverless::Function
    Properties:
      Handler: handler.oauth2Token
      CodeUri: ./oauth2Token
      Runtime: nodejs16.x
      Policies:
        - DynamoDBCrudPolicy:
            TableName: !Ref OperacionTable
      Events:
        MyAPI:
          Type: Api
          Properties:
            Path: /oauth2Token
            Method: POST
            RestApiId:
              Ref: UnifiedApi            
      Environment:
        Variables:
          TABLE_NAME: !Ref OperacionTable

  OperacionTable:
    Type: AWS::DynamoDB::Table
    Properties:
      TableName: Operacion
      AttributeDefinitions:
        - AttributeName: id
          AttributeType: S
      KeySchema:
        - AttributeName: id
          KeyType: HASH
      ProvisionedThroughput:
        ReadCapacityUnits: 1
        WriteCapacityUnits: 1            
  


  # Unified API Definition
  UnifiedApi:
    Type: AWS::Serverless::Api
    Properties:
      StageName: Prod
      DefinitionBody:
        swagger: '2.0'
        info:
          title: "API access to Summary"        
        paths:
          /informePersona:
            post:
              consumes:
                - "application/json"
              produces:
                - "application/json"
              responses:
                "200":
                  description: "200 response"
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${InformePersonaFunction.Arn}/invocations
                passthroughBehavior: when_no_match
                httpMethod: POST
                type: aws_proxy
          /generateJWT:
            post:
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${GenerateJWTFunction.Arn}/invocations
                passthroughBehavior: when_no_match
                httpMethod: POST
                type: aws_proxy
          /oauth2Token:
            post:
              consumes:
                - "application/json"
              produces:
                - "application/json"
              responses:
                "200":
                  description: "200 response"
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${Oauth2TokenFunction.Arn}/invocations
                passthroughBehavior: when_no_match
                httpMethod: POST
                type: aws_proxy


  # Transaction API Definition
  TransactionApi:
    Type: AWS::Serverless::Api
    Properties:
      StageName: Prod
      DefinitionBody:
        swagger: '2.0'
        info:
          title: "API access to Transactions"
        paths:
          /transaction:
            post:
              consumes:
                - "application/json"
              produces:
                - "application/json"
              responses:
                "200":
                  description: "200 response"
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${TransactionsFunction.Arn}/invocations
                passthroughBehavior: when_no_match
                httpMethod: POST
                type: aws_proxy
            options:
              consumes:
                - "application/json"
              produces:
                - "application/json"
              responses:
                "200":
                  description: "CORS support"
                  headers:
                    Access-Control-Allow-Origin:
                      type: "string"
                      default: "*"
                    Access-Control-Allow-Methods:
                      type: "string"
                      default: "POST, OPTIONS"
                    Access-Control-Allow-Headers:
                      type: "string"
                      default: "Content-Type,X-Amz-Date,Authorization,X-Api-Key,X-Amz-Security-Token"
              x-amazon-apigateway-integration:
                type: "mock"
                requestTemplates:
                  application/json: |
                    {
                      "statusCode": 200
                    }
                responses:
                  default:
                    statusCode: "200"
                    responseParameters:
                      method.response.header.Access-Control-Allow-Origin: "'*'"
                      method.response.header.Access-Control-Allow-Methods: "'POST, OPTIONS'"
                      method.response.header.Access-Control-Allow-Headers: "'Content-Type,X-Amz-Date,Authorization,X-Api-Key,X-Amz-Security-Token'"
                    responseTemplates:
                      application/json: |
                        {}

Outputs:
  UnifiedApiUrl:
    Description: "Unified API Gateway endpoint URL"
    Value: !Sub "https://${UnifiedApi}.execute-api.${AWS::Region}.amazonaws.com/Prod"

  UnifiedApiId:
    Description: "Unified API Gateway ID"
    Value: !Ref UnifiedApi


  TransactionApiUrl:
    Description: "Transaction API Gateway endpoint URL"
    Value: !Sub "https://${TransactionApi}.execute-api.${AWS::Region}.amazonaws.com/Prod"

  TransactionApiId:
    Description: "Transaction API Gateway ID"
    Value: !Ref UnifiedApi

